#include "sparse.h"

/*
./hit graph.bin n1 n2 n3
computes the hiting tme from node n1 to all nodes and writes the result in a file named n1.
Do the same for n2, n3 and n4...
The graph must be connected
*/


int main(int argc,char** argv){
	struct sparse *mat, *lap, *lap2;
	unsigned n,i,j,n2,a,node;
	double *diag, *vect, *x, *y;
	FILE *file;

	mat=file2sparse(argv[1]);	

	n=mat->dim;

	printf("Building laplacian\n");

	lap=mklap(mat);
	freesparse(mat);

	diag=getdiag(lap);

	n2=n-1;
	vect=calloc(n2,sizeof(double));
	x=calloc(n,sizeof(double));

	for (a=2;a<argc;a++) {
		node=atoi(argv[a]);

		printf("Computing hitting time to node %u:\n",node);

		lap2=rmlines(lap,&node,1);
		j=0;
		for (i=0;i<n;i++) {
			if (i==node) {
				j=1;
				continue;
			}
			vect[i-j]=diag[i];
		}

		y=conjgrad(lap2,vect);

		printf("Writing the result for node %u\n",node);

		j=0;
		for (i=0;i<n;i++) {
			if (i==node) {
				x[i]=0,j=1;
				continue;
			}
			x[i]=y[i-j];
		}
		freesparse(lap2),free(y);
	
		file=fopen(argv[a],"w");
		for (i=0;i<n;i++) {
			fprintf(file,"%u %lf\n",i,x[i]);
		}
		fclose(file);
	}
	freesparse(lap),free(x),free(vect),free(diag);
	return 0;
}

