#include "sparse.h"

/*
./nonback graph.bin l n1 n2 n3 n4...
Computes all Non-Backtracking Path (NBP) of length less than l between node n1 and all nodes and write the outpout in a file named n1.
Do the same for n2, n3 and n4...
*/


int main(int argc,char** argv){
	struct sparse *mat;
	unsigned i,j,n,l,node,length=atoi(argv[2]);
	unsigned *deg;
	unsigned long long **xx;
	FILE *file;

	mat=file2sparse(argv[1]);
	n=mat->dim;

	deg=calloc(n,sizeof(unsigned));
	for (i=0;i<n;i++) {
		deg[i]=mat->degcum[i+1]-mat->degcum[i];
	}



	for (l=3;l<argc;l++) {
		node=atoi(argv[l]);
		xx=nonback(mat,node,length);
		printf("printing to file\n");
		file=fopen(argv[l],"w");
		for (i=0;i<n;i++) {
			fprintf(file,"%u ",i);
			for(j=0;j<length;j++) {
				fprintf(file,"%llu ",xx[j][i]);
			}
			fprintf(file,"%llu\n",xx[j][i]);
		}
		fclose(file);
		for(j=0;j<length+1;j++) {
				free(xx[j]);
			}
		free(xx);
	}		
	return 0;
}


