#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define ERR 1E-12 // error for the iterative preconditioned conjugate gradient method
#define EPS 1E-10 //precision for the convergence of the carryover opinion
#define REP 100 // max number of iterations for the convergence of the carryover opinion

struct sparse {
	int is_weighted;
	unsigned dim;	//dimensions of the squared matrix
	unsigned *degcum;	//cumulative degree
	unsigned *neigh;	//list of neighbors
	double *weight;	//Weights
};

void freesparse(struct sparse*);
struct sparse *file2sparse(char*);
void sparse2file(struct sparse*,char*);
struct sparse *mklap(struct sparse*);
struct sparse *rmlines(struct sparse*,unsigned*,unsigned); 
void prodvect(struct sparse*,double*,double*);
double **vp(struct sparse *mat,unsigned d);
double getij(struct sparse*,unsigned,unsigned);
double *getdiag(struct sparse*);
double *getsqrtdiag(struct sparse*);
double *precond(struct sparse*,double*);
double *conjgrad(struct sparse*,double*);
unsigned *sparse_kmeans(struct sparse*,unsigned);
unsigned *sparse_SBM(struct sparse*,unsigned);
int compare_unsigned_int (void const*, void const*);
void sortsparse(struct sparse*);
double jaccard(unsigned*,unsigned,unsigned*,unsigned);
struct sparse *mkjac(struct sparse*);
unsigned *bfs(struct sparse *,unsigned,unsigned);
double *htsim(struct sparse *,unsigned,unsigned,unsigned);
unsigned long long **nonback(struct sparse *,unsigned,unsigned);
